# -*- coding: utf-8 -*-
"""
Created on Tue Jul 17 10:15:01 2018

@author: hanye
"""

from es_hy_sign_in import es
import sys
import datetime


def cal_monthly_net_inc_test_range(fetch_year, fetch_month, fetch_day,
                        fetch_hour=0,
                        fetch_time_seg_hours=24,
                        doc_type_target='daily-url',
                        search_body_logic_part=None,
                        threads_num=5,
                        logger_name='calculate_monthly_net_inc',
                        f_log=sys.stdout):

    print('************In func:', file=f_log)
    print('fetch_year:', fetch_year, file=f_log)
    print('fetch_month:', fetch_month, file=f_log)
    print('fetch_day:', fetch_day, file=f_log)
    print('fetch_hour:', fetch_hour, file=f_log)
    print('fetch_time_seg_hours:', fetch_time_seg_hours, file=f_log)
    print('doc_type_target:', doc_type_target, file=f_log)
    print('search_body_logic_part:', search_body_logic_part, file=f_log)
    print('threads_num:', threads_num, file=f_log)
    print('logger_name:', logger_name, file=f_log)
    date_passed_in = datetime.datetime(year=fetch_year, month=fetch_month,
                                       day=fetch_day, hour=fetch_hour)
    fetch_time_start_ts = int(date_passed_in.timestamp()*1e3)
    fetch_time_end_ts = int((date_passed_in
                             + datetime.timedelta(seconds=fetch_time_seg_hours*3600)
                            ).timestamp()*1e3)
    fetch_time_start_iso = datetime.datetime.fromtimestamp(
        int(fetch_time_start_ts/1e3)).isoformat()
    fetch_time_end_iso = datetime.datetime.fromtimestamp(
        int(fetch_time_end_ts/1e3)).isoformat()
    print('fetch_time_start_iso:', fetch_time_start_iso, file=f_log)
    print('fetch_time_end_iso:', fetch_time_end_iso, file=f_log)

    release_time_start_ts = int((date_passed_in - datetime.timedelta(days=180))
                                .timestamp()*1000)
    release_time_end_ts = int((date_passed_in + datetime.timedelta(days=365))
                              .timestamp()*1000)
    release_time_start_T = datetime.datetime.fromtimestamp(release_time_start_ts/1e3)
    release_time_end_T = datetime.datetime.fromtimestamp(release_time_end_ts/1e3)
    print('release_time_start:', release_time_start_T, file=f_log)
    print('release_time_end:', release_time_end_T, file=f_log)

    search_body = {
        "query": {
            "bool": {
                "filter": [
                    {"range": {"release_time": {
                        "gte": release_time_start_ts,
                        "lt": release_time_end_ts}}
                    },
                    {"range": {"fetch_time": {
                        "gte": fetch_time_start_ts,
                        "lt": fetch_time_end_ts}}
                    }
                ],
            }
        },
        "size": 2,
        "aggs": {
            "release_time_distribution": {
                "date_histogram": {
                    "field": "release_time",
                    "interval": "day",
                    "time_zone": "Asia/Shanghai"
                }
            }
        }
    }
    if search_body_logic_part is not None:
        if 'filter' in search_body_logic_part:
            search_body['query']['bool']['filter'].append(search_body_logic_part['filter'])
        else:
            search_body['query']['bool'].update(search_body_logic_part)
    else:
        pass
    search_body_str = search_body.__str__().replace('\'', '"')
    print('search_body:', search_body_str, file=f_log)
    search_resp = es.search(index='short-video-production',
                             doc_type='daily-url-2018-06-30',
                             body=search_body)
    total_hit = search_resp['hits']['total']
    print('search hits:', total_hit, file=f_log)


runday = datetime.datetime.now()
if runday.day == 1:
    last_day_in_the_month_T = runday - datetime.timedelta(days=1)
else:
    if runday.month == 1:
        month_pre = 12
        year_pre = runday.year - 1
        last_day_in_the_month_T = datetime.datetime(year_pre, month_pre, 31)
    else:
        month_pre = runday.month - 1
        year_pre = runday.year
        last_day_in_the_month_T = (datetime.datetime(year_pre, runday.month, 1)
                                   - datetime.timedelta(days=1))
last_day_in_the_month_str = last_day_in_the_month_T.isoformat()[:10]
doc_type_monthly = 'daily-url-%s' % last_day_in_the_month_str
first_day_in_next_month_T = last_day_in_the_month_T + datetime.timedelta(days=1)
year_start = last_day_in_the_month_T.year
month_start = last_day_in_the_month_T.month
cal_month_str = datetime.datetime.strftime(last_day_in_the_month_T, '%b%Y')
cal_month_T = last_day_in_the_month_T

logger_name = 'calculate_MNI_for_missed'
thread_num = 5
search_body_for_missed_MNI_logic_part = {
    "must_not": [
        {"exists": {"field": "monthly_cal_base"}}
    ]
}

cal_day_T = datetime.datetime(year_start, month_start, 2)
step_hours = 4
log_fn = 'test_range_for_MNI_missed_cal_%s.log' % datetime.datetime.now().isoformat()[:19].replace(':', '-')
log_pth = r'D:\CSM\Docs\Projects\短视频\code\write-data-into-es\test'
f_log = open(log_pth+'/'+log_fn, 'w', encoding='utf-8')
while cal_day_T <= first_day_in_next_month_T+datetime.timedelta(days=1):
    print(cal_day_T)
    cal_monthly_net_inc_test_range(cal_day_T.year, cal_day_T.month, cal_day_T.day,
                        fetch_hour=cal_day_T.hour,
                        fetch_time_seg_hours=step_hours,
                        doc_type_target=doc_type_monthly,
                        search_body_logic_part=search_body_for_missed_MNI_logic_part,
                        threads_num=thread_num,
                        logger_name=logger_name,
                        f_log=f_log)
    cal_day_T = cal_day_T + datetime.timedelta(seconds=step_hours*3600)

f_log.close()
