# encoding: utf-8
'''
@author: zhangjian
@time: 2018/11/22 15:10
'''
from elasticsearch import Elasticsearch
from elasticsearch import exceptions
from elasticsearch.helpers import scan
from urllib.parse import quote
import json
import pandas as pd
import datetime
import copy

hosts = '192.168.17.11'
port = 80
user = 'zhouyujiang'
passwd = '8tM9JDN2LVxM'
http_auth = (user, passwd)

es = Elasticsearch(hosts=hosts, port=port, http_auth=http_auth)
sv_index = 'short-video-production'
sv_doc = 'daily-url'
wr_index = 'short-video-production'
wr_doc = 'daily-url'
platfrom_list = [
    'haokan',
]
count = 0
bulk_all_body = ''
for platfrom in platfrom_list:
    search_body = {
        "query": {
            "bool": {
                "filter": [
                    {"term": {"platform.keyword": platfrom}},
                    {"term": {"data_provider.keyword": "CCR"}}
                ],
                "must": [
                    {
                        "match_phrase": {
                            "url": "nid"
                        }
                    }
                ]
            }
        }
    }
    search_resp = scan(client=es, index=sv_index, doc_type=sv_doc, query=search_body)
    for line in search_resp:
        count += 1
        one_dict = {}

        #dayil-url
        fetch_time_int = int(line['_source']['fetch_time'] / 1000)
        fetch_time_H = datetime.datetime.fromtimestamp(fetch_time_int)
        year=fetch_time_H.year
        month=fetch_time_H.month
        day=fetch_time_H.day
        date_str='_'+str(year)+'-'+str(month)+'-'+str(day)

        one_dict.update(line['_source'])
        vid = line['_source']['video_id']
        url= 'https://sv.baidu.com/videoui/page/videoland?context=' + quote('{\"nid\":\"sv_' + vid + "\"}")
        new_id=url+date_str
        # print(new_id)
        one_dict.update({"data_provider": "CCR_2",
                         "url": url})
        bulk_head = '{"index": {"_id":"%s"}}' % new_id
        data_str = json.dumps(one_dict, ensure_ascii=False)
        bulk_one_body = bulk_head + '\n' + data_str + '\n'
        bulk_all_body += bulk_one_body

        if count % 1000 == 0:
            eror_dic = es.bulk(index=wr_index, doc_type=wr_doc,
                               body=bulk_all_body, request_timeout=200)
            bulk_all_body = ''
            if eror_dic['errors'] is True:
                print(eror_dic['items'])
                print(bulk_all_body)
            print(count)

    if bulk_all_body != '':
        eror_dic = es.bulk(body=bulk_all_body,
                           index=wr_index,
                           doc_type=wr_doc,
                           request_timeout=200)
        if eror_dic['errors'] is True:
            print(eror_dic)

    bulk_all_body = ''
    print("end")
